/*
  ==============================================================================

  This is an automatically generated GUI class created by the Projucer!

  Be careful when adding custom code to these files, as only the code within
  the "//[xyz]" and "//[/xyz]" sections will be retained when the file is loaded
  and re-saved.

  Created with Projucer version: 5.4.4

  ------------------------------------------------------------------------------

  The Projucer is part of the JUCE library.
  Copyright (c) 2017 - ROLI Ltd.

  ==============================================================================
*/

//[Headers] You can add your own extra header files here...
//[/Headers]

#include "MainComponent.h"


//[MiscUserDefs] You can add your own user definitions and misc code here...
//[/MiscUserDefs]

//==============================================================================
MainComponent::MainComponent ()
{
    //[Constructor_pre] You can add your own custom stuff here..
    //[/Constructor_pre]

    tbRecord.reset (new TextButton ("new button"));
    addAndMakeVisible (tbRecord.get());
    tbRecord->setButtonText (TRANS("Record"));
    tbRecord->addListener (this);

    tbRecord->setBounds (8, 8, 150, 24);

    tbStop.reset (new TextButton ("new button"));
    addAndMakeVisible (tbStop.get());
    tbStop->setButtonText (TRANS("Stop"));
    tbStop->addListener (this);

    tbStop->setBounds (8, 40, 150, 24);


    //[UserPreSize]
    //[/UserPreSize]

    setSize (600, 400);


    //[Constructor] You can add your own custom stuff here..
    edit = std::make_unique<te::Edit>(engine, te::createEmptyEdit(), te::Edit::forEditing, nullptr, 0);
    edit->ensureNumberOfAudioTracks(1);
    auto track = te::getAudioTracks(*edit)[0];

    edit->playInStopEnabled = true;

    auto& dm = engine.getDeviceManager();

    for (int i = 0; i < dm.getNumMidiInDevices(); i++)
    {
        if (auto wip = dm.getMidiInDevice(i))
        {
            wip->setEndToEndEnabled(true);
            wip->setEnabled(true);
        }
    }

    edit->restartPlayback();

    for (auto instance : edit->getAllInputDevices())
    {
        if (instance->getInputDevice().getDeviceType() == te::InputDevice::physicalMidiDevice)
        {
            instance->setTargetTrack(track, 0);
            instance->setRecordingEnabled(true);
        }
    }

    edit->restartPlayback();
    //[/Constructor]
}

MainComponent::~MainComponent()
{
    //[Destructor_pre]. You can add your own custom destruction code here..
    //[/Destructor_pre]

    tbRecord = nullptr;
    tbStop = nullptr;


    //[Destructor]. You can add your own custom destruction code here..
    //[/Destructor]
}

//==============================================================================
void MainComponent::paint (Graphics& g)
{
    //[UserPrePaint] Add your own custom painting code here..
    //[/UserPrePaint]

    g.fillAll (Colour (0xff323e44));

    //[UserPaint] Add your own custom painting code here..
    //[/UserPaint]
}

void MainComponent::resized()
{
    //[UserPreResize] Add your own custom resize code here..
    //[/UserPreResize]

    //[UserResized] Add your own custom resize handling here..
    //[/UserResized]
}

void MainComponent::buttonClicked (Button* buttonThatWasClicked)
{
    //[UserbuttonClicked_Pre]
    //[/UserbuttonClicked_Pre]

    if (buttonThatWasClicked == tbRecord.get())
    {
        //[UserButtonCode_tbRecord] -- add your button handler code here..
        auto& transport = edit->getTransport();
        transport.record(false);
        //[/UserButtonCode_tbRecord]
    }
    else if (buttonThatWasClicked == tbStop.get())
    {
        //[UserButtonCode_tbStop] -- add your button handler code here..
        auto& transport = edit->getTransport();
        transport.stop(true, false);
        //[/UserButtonCode_tbStop]
    }

    //[UserbuttonClicked_Post]
    //[/UserbuttonClicked_Post]
}



//[MiscUserCode] You can add your own definitions of your custom methods or any other code here...
//[/MiscUserCode]


//==============================================================================
#if 0
/*  -- Projucer information section --

    This is where the Projucer stores the metadata that describe this GUI layout, so
    make changes in here at your peril!

BEGIN_JUCER_METADATA

<JUCER_COMPONENT documentType="Component" className="MainComponent" componentName=""
                 parentClasses="public Component" constructorParams="" variableInitialisers=""
                 snapPixels="8" snapActive="1" snapShown="1" overlayOpacity="0.330"
                 fixedSize="0" initialWidth="600" initialHeight="400">
  <BACKGROUND backgroundColour="ff323e44"/>
  <TEXTBUTTON name="new button" id="21c2802430ce7980" memberName="tbRecord"
              virtualName="" explicitFocusOrder="0" pos="8 8 150 24" buttonText="Record"
              connectedEdges="0" needsCallback="1" radioGroupId="0"/>
  <TEXTBUTTON name="new button" id="1079c06db5ff0980" memberName="tbStop" virtualName=""
              explicitFocusOrder="0" pos="8 40 150 24" buttonText="Stop" connectedEdges="0"
              needsCallback="1" radioGroupId="0"/>
</JUCER_COMPONENT>

END_JUCER_METADATA
*/
#endif


//[EndFile] You can add extra defines here...
//[/EndFile]

